Bug 1348160 - Review Request: rubygem-em-proxy - EventMachine Proxy DSL
Summary: Review Request: rubygem-em-proxy - EventMachine Proxy DSL
Keywords:
Status: CLOSED WONTFIX
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Nobody's working on this, feel free to take it
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1348005
TreeView+ depends on / blocked
 
Reported: 2016-06-20 10:16 UTC by Germano Massullo
Modified: 2017-12-04 14:19 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-12-04 14:19:38 UTC
Type: Bug
germano.massullo: fedora-review?


Attachments (Terms of Use)

Description Germano Massullo 2016-06-20 10:16:35 UTC
Description: EventMachine Proxy DSL for writing high-performance transparent / intercepting proxies in Ruby.

Spec: https://germano.fedorapeople.org/package_reviews/rubygem-em-proxy/rubygem-em-proxy.spec

Source RPM: https://germano.fedorapeople.org/package_reviews/rubygem-em-proxy/rubygem-em-proxy-0.1.8-1.fc23.src.rpm

FAS name: germano

Comment 1 Fabio Alessandro Locati 2016-07-06 06:50:29 UTC
Things to fix/improve:
- Include the LICENSE file in the package
- Exclude the .rspec folder from the rpm package
- Fix script-without-shebang /usr/share/gems/gems/em-proxy-0.1.8/examples/balancing-client.rb
- Align file SPEC with SRPM






This is a review *template*. Besides handling the [ ]-marked tests you are
also supposed to fix the template before pasting into bugzilla:
- Add issues you find to the list of issues on top. If there isn't such
  a list, create one.
- Add your own remarks to the template checks.
- Add new lines marked [!] or [?] when you discover new things not
  listed by fedora-review.
- Change or remove any text in the template which is plain wrong. In this
  case you could also file a bug against fedora-review
- Remove the "[ ] Manual check required", you will not have any such lines
  in what you paste.
- Remove attachments which you deem not really useful (the rpmlint
  ones are mandatory, though)
- Remove this text



Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated". 27 files have unknown license. Detailed
     output of licensecheck in /home/fale/1348160-rubygem-em-
     proxy/licensecheck.txt
[!]: License file installed when any subpackage combination is installed.
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/share/gems,
     /usr/share/gems/doc
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Avoid bundling fonts in non-fonts packages.
     Note: Package contains font files
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in rubygem-
     em-proxy-doc
[ ]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: When checking ruby code, install the ruby plugin.
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see
     attached diff).
     See: (this test has no URL)
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Checking: rubygem-em-proxy-0.1.8-1.fc24.noarch.rpm
          rubygem-em-proxy-doc-0.1.8-1.fc24.noarch.rpm
          rubygem-em-proxy-0.1.8-1.fc24.src.rpm
rubygem-em-proxy.noarch: W: no-documentation
rubygem-em-proxy.noarch: W: hidden-file-or-dir /usr/share/gems/gems/em-proxy-0.1.8/.rspec
rubygem-em-proxy.noarch: W: no-manual-page-for-binary em-proxy
rubygem-em-proxy-doc.noarch: E: script-without-shebang /usr/share/gems/gems/em-proxy-0.1.8/examples/balancing-client.rb
3 packages and 0 specfiles checked; 1 errors, 3 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
rubygem-em-proxy-doc.noarch: E: script-without-shebang /usr/share/gems/gems/em-proxy-0.1.8/examples/balancing-client.rb
rubygem-em-proxy.noarch: W: no-documentation
rubygem-em-proxy.noarch: W: hidden-file-or-dir /usr/share/gems/gems/em-proxy-0.1.8/.rspec
rubygem-em-proxy.noarch: W: no-manual-page-for-binary em-proxy
2 packages and 0 specfiles checked; 1 errors, 3 warnings.



Diff spec file in url and in SRPM
---------------------------------
--- /home/fale/1348160-rubygem-em-proxy/srpm/rubygem-em-proxy.spec	2016-07-04 21:41:28.397728479 +0100
+++ /home/fale/1348160-rubygem-em-proxy/srpm-unpacked/rubygem-em-proxy.spec	2016-06-20 10:35:04.000000000 +0100
@@ -6,4 +6,5 @@
 Release: 1%{?dist}
 Summary: EventMachine Proxy DSL
+Group: Development/Languages
 License: MIT
 URL: http://github.com/igrigorik/em-proxy
@@ -19,9 +20,10 @@
 
 %description
-EventMachine Proxy DSL for writing high-performance
-transparent / intercepting proxies in Ruby.
+EventMachine Proxy DSL.
+
 
 %package doc
 Summary: Documentation for %{name}
+Group: Documentation
 Requires: %{name} = %{version}-%{release}
 BuildArch: noarch


Requires
--------
rubygem-em-proxy-doc (rpmlib, GLIBC filtered):
    rubygem-em-proxy

rubygem-em-proxy (rpmlib, GLIBC filtered):
    /usr/bin/env
    /usr/bin/ruby
    ruby(rubygems)
    rubygem(eventmachine)



Provides
--------
rubygem-em-proxy-doc:
    rubygem-em-proxy-doc

rubygem-em-proxy:
    rubygem(em-proxy)
    rubygem-em-proxy



Source checksums
----------------
https://rubygems.org/gems/em-proxy-0.1.8.gem :
  CHECKSUM(SHA256) this package     : c60370495546eaacfc62bc70cb074a40b5b88c705427c404e26fc0d7714f6ebe
  CHECKSUM(SHA256) upstream package : c60370495546eaacfc62bc70cb074a40b5b88c705427c404e26fc0d7714f6ebe


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1348160
Buildroot used: fedora-24-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 2 Germano Massullo 2016-07-10 22:04:57 UTC
Should I patch also other Shebangs in source code, as written in Ruby guidelines?
https://fedoraproject.org/wiki/Packaging:Ruby#Shebang_lines
Example:
#!/usr/bin/ruby
instead of
#!/usr/bin/env ruby

Comment 3 Fabio Alessandro Locati 2016-07-13 16:01:32 UTC
@Germano: The result for both is the same, so I would say that it does not really matter. If upstream uses `env ruby` is ok. That phrase compares using ruby vs ruby-mri/jruby

Comment 4 Germano Massullo 2016-07-14 13:35:34 UTC
Personal reminder: LICENSE file included in rubygem version 0.1.9
https://github.com/igrigorik/em-proxy/issues/56

Comment 5 Fabio Alessandro Locati 2016-07-15 16:22:33 UTC
@Germano: You _should_ probably rebase this package on 0.1.9

Comment 6 Germano Massullo 2016-07-15 17:23:14 UTC
(In reply to Fabio Alessandro Locati from comment #5)
> @Germano: You _should_ probably rebase this package on 0.1.9

I know but I am waiting for Francesco Frassinelli comment about Ruby shebangs. He claims to be pretty sure about
#!/usr/bin/ruby
usage

Comment 7 Francesco Frassinelli (frafra) 2016-07-15 18:08:15 UTC
I would suggest to avoid env for Fedora packages for two reasons:

1. Fedora wiki suggests to use #!/usr/bin/ruby and #!/usr/bin/python
2. You don't want to get different behaviour/errors from your system tools when you are in a virtualenv (or ruby equivalent)

I think that env is fine for upstream code and bad for system packages. There are a lot of spec file replacing shebangs using env.

Comment 8 Fabio Alessandro Locati 2016-07-18 10:06:55 UTC
1. Rebase on 0.19
2. Remove /usr/share/gems/gems/em-proxy-0.1.8/.rspec
3. /usr/share/gems/gems/em-proxy-0.1.8/examples/balancing-client.rb is missing the shabang
4. Use #!/usr/bin/ruby instead of #!/usr/bin/env ruby (thanks Frafra :))
5. Make sure that the spec file and the SPEC file inside the SRPM are the _SAME_

Comment 9 Vít Ondruch 2016-07-18 10:49:47 UTC
(In reply to Francesco Frassinelli (frafra) from comment #7)
> I would suggest to avoid env for Fedora packages for two reasons:
> 
> 1. Fedora wiki suggests to use #!/usr/bin/ruby and #!/usr/bin/python
> 2. You don't want to get different behaviour/errors from your system tools
> when you are in a virtualenv (or ruby equivalent)
> 
> I think that env is fine for upstream code and bad for system packages.
> There are a lot of spec file replacing shebangs using env.

While your both points are valid, we typically don't change the shebangs in rubygems.

The thing is that the executable, which is installed into /usr/bin has always the /usr/bin/ruby shebang, since this is generated file. There is just minimal chance, that the files which goes into %{gem_instdir}, or even files which goes into %{gem_instdir}/bin will be executed directly by user, so there is no real reason to change the shebangs IMO (unless you want to avoid the Requires: /usr/bin/env autogenerated by RPM, but in that case, it might be better to filter this autogenerated Requires ...)

Comment 11 Fabio Alessandro Locati 2016-08-10 10:05:00 UTC
SOURCE1 is not used anywhere. It should be used somewhere or removed

Comment 12 Vít Ondruch 2016-08-10 10:09:14 UTC
BTW it would be also good idea to execute some test suite, if that is available ...

Comment 13 Germano Massullo 2016-08-10 13:24:59 UTC
(In reply to Fabio Alessandro Locati from comment #11)
> SOURCE1 is not used anywhere. It should be used somewhere or removed

it is still required in lastest em-proxy release

Comment 14 Fabio Alessandro Locati 2016-08-23 22:04:36 UTC
ok, then use it, because ATM you are adding it to the package but you are not using it

Comment 15 Germano Massullo 2017-12-04 14:19:38 UTC
Closing because I no longer need this package


Note You need to log in before you can comment on or make changes to this bug.